=======
HISTORY
=======

                  METADRAW .NET FOR WINFORMS 2 
                     UPDATE HISTORY


The most recent build of MetaDraw .NET for Winforms is 2.0.16

 
IMPORTANT NOTES 

    = FOR USERS UPGRADING FROM PREVIOUS METADRAW.NET EDITIONS = 


1)  INSTALLATION - REPLACING OLD INSTALLATION

   If updating by use of new installation kit,
   the previous editions of MetaDraw .NET 2 should 
   be uninstalled before installing a newer build 

2)  UPDATING PROJECTS - DESIGN TIME SETTINGS

   As a rule Bennet-Tec strongly recommends NOT 
   setting MetaDraw picture properties at design time
   This includes the settings of the following properties
         Picture, PictureImage, BackPicture

   Because Visual Studio .NET stores the version number of the
   picture related properties as part of the resource, 
   an error can occur when trying to use a newer build of 
   MetaDraw to run or compile an old project where these 
   have been set at design time.    
   When updating to a new build of MetaDraw .Net, 
   projects which had such design-time assignments for MetaDraw 
   pictures must be manually updated - to remove any previously 
   assigned MetaDraw Picture from the project resource file 
   The picture may then be reassigned as a new design time 
   property setting but again we recommend setting picture 
   properties only with run-time code. ( for instance initializing
   these properties in a form load event ).

   Rather than set picture properties at design time
   if the programmer wishes to store images using a resource
   file the recommended approach is 
      a) Add image to the solution 
      b) property window for this image set 
         the "Type" or "build action" to "Embedded Resource"
      b) In Form_Load event ( or any other event ) you can 
         then set the desired MetaDraw picture property
         with this image from the resource file.
         for example: 
              Dim s As System.IO.Stream =
                   Me.GetType().Module.Assembly
                  .GetManifestResourceStream("Create.Image.WMF")
               MetaDraw1.LoadPicture(s, PictureSource.PictureImage)


--------------------------------------------
MetaDraw 2.0.16.0 build from	Feb 28, 2010
--------------------------------------------

ENHANCEMENT	DXF Import
	Added ability to support addition DXF features : 
 	        *. Added Support for loading DXF files with multiline objects
 	        *. Added Support for loading DXF files with rotated objects
 	        *. Added Support for loading DXF files with rotation by vector instead of angle.
 	        *. Calculation of picture area was updated

		*** DXF Import requires purchase
		     of   DXF Import license option ****

Update	Installation Kit - VS .NET Toolbox

	MetaDraw is automatically added to VS .NET Toolbox 
	when possible.

	There had been a problem if multiple versions of VS.NET 
	existed - MetaDraw was only placed in Toolbox of one 
	instance of Visual Studio.   Now MetaDraw will be added
	to toolbox for all existing toolboxes.

	NOTE:   Visual Studio must be closed when running MetaDraw
	Installation kit.   If Visual Studio is open when installing MetaDraw,
	the MetaDraw component will be added to the toolbox but when 
	you close VS and reopen it will return to the toolbox state without MetaDraw

UPDATE 	Installation Kit - Documents

	Documents such as "ReadMe" included in Installation kit were updated

	New document "Application Distribut Notes.RTF" added 
	to assist users when distributing MetaDraw based applications


UPDATE 	Installation Kit - Graphics Library Folder Renamed

	The graphics library contains bitmap and icon files 
	for use by customers in their applications 
	(in toolbars, or as MetaDraw custom cursors). 



--------------------------------------------
MetaDraw 2.0.15.0 build from	Jan 19, 2009
--------------------------------------------

ENHANCEMENT	DXF exporting		(ID#14790)

	It is now possible to export MetaDraw objects
	with Dash-Dot styles into DXF file

	*** DXF Export requires purchase
                       of DXF Export license option ****


CHANGED	MetaDraw .NET 2.0 Samples

	Some sample projects were added/updated.

ADDED 	A small library of bitmap and icon files was added to the installation kit
	for use by customers in their applications 
	(in toolbars, or as MetaDraw custom cursors). 

FIXED	License registration

	The OK message sometimes appeared behind the main 
	screen of the license utility - apparently freezing the utility.
	This has been corrected


CHANGED	Compatibility with old applications.
	Now old applications created with older
	versions of MetaDraw .NET 2.0 will also work 
	with newer versions of MetaDraw component.


--------------------------------------------
MetaDraw 2.0.14.0 build from	Dec 30, 2009
--------------------------------------------

	
ENHANCEMENT	DXF exporting		(ID#14790)

	DXF saving mechanisms have been rewritten for enhanced
	support of DXF Export - compatible with the latest versions
	of AutoCad.    ( Tested with AutoCAD versions through 2010 ) 

	DXF files created with MetaDraw can now also include
	  - Container/Layer names 
	      ( Layer names are preserved when loading DXF files 
	      into MetaDraw and resaving to DXF), 
	  - ObjTags ( saved as Data )
	  - Dash-Dot lines, 

	*** DXF Export requires purchase
                       of DXF Export license option ****

ENHANCEMENT    Loading Icons from memory  	(ID#14939)

	The LoadPicture method can now accept an Icon object as
	a source image:

	    MD.LoadPicture( New Icon( "icon.ico" ), PictureSource.PictureImage )

FIXED	BackPicture 		(ID#14956)

	Now it is possible to export the BackPicture using 
	the SavePicture method.

FIXED	Transparency for Icon images - response to Microsoft   (ID#14939)

	After installing a recent Microsoft patch, Icons loaded 
	using the  Image.FromFile(...) method lost their transparency .
	MetaDraw has now been adjusted to account for Microsoft's  "Fix"
	
--------------------------------------------
MetaDraw 2.0.13.0 build from	Nov 24, 2009
--------------------------------------------

ENHANCEMENT Compatibility with MetaDraw OCX

	MDP files created in both .NET & OCX versions of MetaDraw 
	are fully compatible now.
	
CHANGED	Image insertion by mouse	(ID#14425)

	Now when a bitmap image is inserted info MetaDraw picture
	using EditMode = ED_IMAGE it will be represented
	as a single image without surrounding container.	
	Previously such an image was inserted as a image object
	held in a container.   For a single object there is no need
	for the container ( group ) 


FIXED	Container with zero size objects (ID#14535)

	Boundaries of containers that contain objects with 
	zero bounds (like points) were calculated incorrectly

FIXED	Links duplication		(ID#14231)

	Link objects (pointed to only one object) were 
	incorrectly duplicated when UnDo mode was active
	
FIXED	Undo/Redo on moved objects	(ID#12249)
	Undo/Redo did not work correctly when object(s) were
	moved using the MoveObjects method.

--------------------------------------------
MetaDraw 2.0.12.0 build from	Sep 02, 2009
--------------------------------------------

ENHANCEMENT 	Windows 7 is now fully supported 

FIXED	Loading MDP file created by OCX edition	(ID#14709)

	Previously the MetaDraw .NET .NET Winforms 2 edition 
	could not read MDP files created by recent builds (3.1.33 or later) 
	of the OCX edition.

	The .NET edition can now read MDP files created by the OCX edition 

--------------------------------------------
MetaDraw 2.0.11.0 build from	Mar 12, 2009
--------------------------------------------

ENHANCEMENT 	Vista now fully supported 

ADDITION  A set of new samples was added to the installation kit.

--------------------------------------------
MetaDraw 2.0.10.0 build from	June 10, 2008
--------------------------------------------

ENHANCEMENT	Background Image - Toggling Display

	It is now possible to hide the background
	image without clearing the BackPicture property.
	This is done by setting the BackPictureAlignment
	property to the new value, BackPictureAlignments.Hidden
	The background may thus be toggled on and off.


ENHANCEMENT   BackPicture 

	A new PictureOptions setting PictureFlags.JoinBackground
	allows more direct joining of the background 
	and foreground ( annotation) layers
	
	With this flag set ( OR'd into value of PictureOptions)
	        Setting BackPicture property will reset the 
	        foreground ( Annotation ) layer.   The annotation
		layer ( Picture property ) will be cleared
		and the size ( OrigWidth, OrigHeight ) will
		be reset to match the size of the BackPicture.
		Previously the user needed to separately set
		the size of the annotation layer.  This is no
		longer needed.

	With this flag cleared 
	        Setting BackPicture property does not affect
	        the foreground ( Annotation ) layer.   

	EXAMPLE:
	     With MetaDraw1
		' To set the flag 
		.PictureOptions = .PictureOptions _
		       OR PictureFlags.JoinBackground
		' To clear the flag 
		.PictureOptions = .PictureOptions _
		       AND NOT PictureFlags.JoinBackground
	     End With 


	** NOTE - unlike the OCX edition - this flag bit does NOT
	** implement rotation of background with annotations


ENHANCEMENT    DXF Export

	DXF Export support has been further enhanced

	*** DXF Export requires purchase
	      of DXF Export license option ****

ENHANCEMENT	Licensing Utility
          
	The licensing utility was updated 
	for improved operation under Vista

ENHANCEMENT      Visual Stuido Toolbox 

	Upon installation MetaDraw is automatically added
	to the Visual Studio Toolbox   
	( previously this needed to be done manually after installation )


FIXED	Zooming backpicture		(SP#13467)

	The Background picture was not zoomed together with
	main picture when PictureFlags.PicBackground was set.


FIXED  Memory leak

	There was a memory leak when setting a FontName
	which is not registered in the user's Windows system.
          
 
FIXED	Transparent Bitmaps		(SP#13530)

	Transparent bitmaps were incorrectly drawn 
	when they were zoomed.


	
--------------------------------------------
MetaDraw 2.0.9.0 build from	May 26, 2008
--------------------------------------------

ENHANCEMENT 	DXF EXPORT
	DXF export support has been extended
	Polygon & PolyBezier objects are now supported

	DXF files created by MetaDraw 
	are now compatible with newer versions of AutoCad (2000+). 

	*** DXF Export requires purchase
	      of DXF Export license option ****

ENHANCEMENT	DXF IMPORT
	Invisible layers ( layers with "Off for display" flag set )
	are now be imported as hidden containers ( with ObjVisible = False) 

***	MetaDraw can now load DXF files which had   (SP#13091)
	been created by other 3rd party applications without 
	header records.

	*** DXF IMPORT requires purchase
	      of DXF Export license option ****


ENHANCEMENT    DXF Scale Factor
***	The DXFScaleFactor property can now be used
	with recent format DXF files to read the scaling
	between DXF coordinates and MetaDraw coordinates
	In recent format DXF files the DXF may specify 
	some units ( inches, feet, meters, parsecs ! ) 
	MetaDraw will determine which measurement system
	is used and will adjust conversion to MetaDraw
	coordinates accordingly.

CHANGE	DXF importing			(SP#13197)

	If measurement units are not defined in DXF file,
	    ( if the DXF file to be imported is missing 
	      a $INSUNITS header record ) 
	MetaDraw will now default to using inches.

	In the past MetaDraw tried to choose a "suitable" resolution 
	by itself ( so loaded picture is not so small, or so big on the screen ).
	With this change, the result of DXF import in such case
	will be more consistant
 
	*** DXF support requires purchase
	      of DXF support license option ****

FIXED  DXF import                         (SP#13264)
	Rotated Text objects were imported incorrectly 
	from DXF files.

	*** DXF support requires purchase
                        of DXF support license option ****


FIXED  Exit while Adding text with UndoGrouping    (SP#13268)

	When UndoGrouping mode was enabled, 
	canceling the operation while adding a text object 
	( hitting Escape while adding text in editmode ED_Text )
	removed all the objects in the current Undo group.

--------------------------------------------
MetaDraw 2.0.8.0 build from	Dec 12, 2007
--------------------------------------------

FIXED	DXF IMPORT		(SP#12774)

	DXF files could not be loaded into MetaDraw
	without Subscription License Support.
	This should not be required - Only DXF Import
	license is required for loading DXF images.

	*** DXF Import requires purchase
                       of DXF Import license option ****


FIXED	Action Property - Duplicate 	(SP#12489)

	Link objects were duplicated incorrectly 
	when using  .Action(Actions.Duplicate) method.

FIXED	Screen Refreshing when Moving Linked Objects

	The MetaDraw display was not properly updated 
        in EFLG_DRAWSCEL mode when using a mouse  
	to move objects with links.

FIXED	Installation kit - SAMPLE projects 

	There was an error ( "unreferenced BTIS.MetaDraw2.DLL") 
	when loading installed MetaDraw samples in VS 2005.

--------------------------------------------
MetaDraw 2.0.7.0 build from	July 17, 2007
--------------------------------------------

ENHANCEMENT 	DXF EXPORT
	DXF export function has been updated.            

	*** DXF Export requires purchase
              of DXF Export license option ****

	*** Requires upgraded License purchase 
             for pre-existing DXF users who do not 
             have Subscription License Option

--------------------------------------------
MetaDraw 2.0.6.0 build from	July 06, 2007
--------------------------------------------

ENHANCEMENT 	DXF EXPORT			(SP#12104)

	DXF files created by MetaDraw 
        are now compatible with newer versions 
        of AutoCad (2000+). 

	*** DXF Export requires purchase
              of DXF Export license option ****

--------------------------------------------
MetaDraw 2.0.5.0 build 		June 21, 2007
--------------------------------------------

FIXED	Licensing - Incompatibility with Infragistics  (SP#11943)

	MetaDraw showed Demo message box 
	even if properly licensed when used in a project 
	together with certain Infragistics components.

FIXED	DXF Import 

	The PictureOptions property did not
	correctly process the InvertDXF flag bit 
	It was not possible to remove black background 
	from DXF images

	*** DXF Import requires purchase
                        of DXF Import license option ****

--------------------------------------------
MetaDraw 2.0.4.1 build from	May 18, 2007
--------------------------------------------

FIXED	Loading MDP files		(SP#11823)

	MetaDraw could not load an MDP file 
	containing SolidPicture objects
	
	( example - an MDP file which had been 
	created by merging a Metafile into the 
	layout as a SolidPicture object, using 
	PictureOptions property, and then 
	by saving as MDP

--------------------------------------------
MetaDraw 2.0.3.1 build from	Mar 12, 2007
--------------------------------------------

ENHANCEMENT   Enhanced DXF Import Support 
        Added support for additional DXF Objects
	*** DXF support requires purchase
              of DXF license option ****

FIXED - #11502  - Creating WMF files

        SavePicture Method
        There was a problem creating simple windows 
        metafiles (WMF ) in .NET 2 framework environment. 
        

FIXED - #11626  - Saving complex pictures to memory stream
        There was a problem saving very large images
        ( more than 200,000 elements ) to stream

--------------------------------------------
MetaDraw  build 2.0.2 	Jan 26, 2007
--------------------------------------------

ENHANCEMENT   
    Installation kit may now be installed
    on both 32-bit and 64-bit environments.

    All samples in new installation kit have been 
    updated and can be normally compiled (and executed) 
    on both 32- and 64-bit Windows.

    Note -  MetaDraw .NET 2.0 is still a 32-bit DLL 
    and while it can now be used in 64 bit 
    environments it can not be used in 64-bit applications. 
    So an application that uses MetaDraw .NET component
    MUST be compiled for x86 platform only 
    (application will not start if it is compiled 
    as AnyCPU or x64 platform).    We are investigating 
    implementation of support  for 64 bit applications 
    and anticipate a MetaDraw edition with this support 
    in the future.

    Note - a license problem may occur While working with VS 2005 
    under 64-bit WINXP.  Microsoft's VS 2005 component license compiler
    fails when compiling a 32-bit application under 64-bit
    environment in VS 2005. See the following Microsoft
    article for details and workaround:
       http://support.microsoft.com/kb/913961


ENHANCEMENT   HTML ImageMaps  
	HTML generated by the CreateImageMap method 
	now includes both 'alt' and 'title' attributes 
        in the <MAP> tag if .ObjTags("TOOLTIP") values
        have been specified for hotspots
	*** Use of this method requires purchase
              of subscription license option ****

ENHANCEMENT   Enhanced DXF Import Support 
        MetaDraw DXF support can now load 
        newer version DXF files ( previously limited 
        to R14  or older )
	*** DXF support requires purchase
              of DXF license option ****
              
ENHANCEMENT   Control over OS Warning Message
        It is now possible to turn off the warning
        when MetaDraw senses a problem on an
        unsupported operating system.
        The property  WarningForUnsupportedOperatingSystem 
        may be set to FALSE - this should be set in design
        time property window so that it is recognized upon
        initialization of the component.
        Note that Bennet-Tec can not guarantee proper 
        performance on unsupported systems but this should
        allow programmers control over the display of the
        warning message
        Metadraw 2.NET is currently supported under
           Windows 2000, XP, 2003 Server
           Vista is not yet formally supported   
           


--------------------------------------------
MetaDraw .NET 2  build 2.0.1 	July 28, 2006
--------------------------------------------

   First release for .NET Framework 2



--------------------------------------------
MetaDraw .NET Winforms 1 - 	Jul 07, 2003
--------------------------------------------

   First formal release for MetaDraw .NET Winforms 1 edition
            
--------------------------------------------
MetaDraw  3 OCX  	
--------------------------------------------
   First release for MetaDraw 3 OCX

--------------------------------------------
MetaDraw  2 OCX  	
--------------------------------------------
   First release for MetaDraw 2 OCX

--------------------------------------------
MetaDraw  1 OCX  	
--------------------------------------------
   First release for MetaDraw 1 OCX ( 32 bit )


--------------------------------------------
MetaDraw  VBX 		1995
--------------------------------------------
   First release for MetaDraw VBX  ( 16 bit )


--------------------------------------------
--------------------------------------------

